#pragma once

#include "ofMain.h"

#include "ofxFft.h"    //FFT functionality!
#include "chuck_fft.h" // Chuck FFT functionality?

#include <math.h>


//-----------------------------------------------------------------------------
// Preprocessor definitions
//-----------------------------------------------------------------------------
#define MY_SRATE         44100            // sample rate
#define MY_CHANNELS      2                // number of channels
//#define MY_BUFFERHISTORY 100               // number of buffers to save
#define MY_BUFFERSIZE    512             // number of frames in a buffer
#define MY_NBUFFERS      2                // number of buffers latency
#define MY_PIE           3.14159265358979 // for convenience


//-----------------------------------------------------------------------------
// My application
//-----------------------------------------------------------------------------
class ofApp : public ofBaseApp{

	public:
		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);
		void drawMobile(int i, int ncopies);


        // Get buffer samples
        void audioIn(float * input, int bufferSize, int nChannels);

        // Our sound stream object
		ofSoundStream soundStream;
        vector<float> left;
        vector<float> right;

        // FFT stuff for Chuck_FFT
        complex fftBuffer[MY_BUFFERSIZE/2];
        float my_window[MY_BUFFERSIZE]; // window to use with FFT

        // Input stuff
        bool fulscr;
        bool cheat;
        bool trailson;
        bool revangle;

        // Chime stuff
        ofSoundPlayer chimes;
        vector<float> power;
        int curPow;
        float chimeVol;
        float powSum;
        float avgPow;
        float accel;
        float mainangle;
        vector<float> miniangles;
        vector<int> miniacceldir;

        // Font stuff
        ofTrueTypeFont myfont;
        int textalpha;

        // Freq domain stuff
        vector< vector<float> > fbinshist;
        vector<float> fbinspow;
        vector< vector<float> > fbinsavg;

};
